
// taken from Ramda Type definitions
declare type CurriedFunction2<T1, T2, R> =
& ((t1: T1, t2: T2) => R)
& ((t1: T1, ...rest: Array<void>) => (t2: T2) => R)

declare type CurriedFunction3<T1, T2, T3, R> =
& ((t1: T1, t2: T2, t3: T3) => R)
& ((t1: T1, t2: T2, ...rest: Array<void>) => (t3: T3) => R)
& ((t1: T1, ...rest: Array<void>) => CurriedFunction2<T2, T3, R>)

declare type CurriedFunction4<T1, T2, T3, T4, R> =
& ((t1: T1, t2: T2, t3: T3, t4: T4) => R)
& ((t1: T1, t2: T2, t3: T3, ...rest: Array<void>) => (t4: T4) => R)
& ((t1: T1, t2: T2, ...rest: Array<void>) => CurriedFunction2<T3, T4, R>)
& ((t1: T1, ...rest: Array<void>) => CurriedFunction3<T2, T3, T4, R>)

declare module spected {
  declare var spected: CurriedFunction2<Object, Object, Function>
  declare var validate: CurriedFunction<Function, Function, Object, Object, Function>
}