'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _mergeDeepWith = require('ramda/src/mergeDeepWith');

var _mergeDeepWith2 = _interopRequireDefault(_mergeDeepWith);

var _keys = require('ramda/src/keys');

var _keys2 = _interopRequireDefault(_keys);

var _zipObj = require('ramda/src/zipObj');

var _zipObj2 = _interopRequireDefault(_zipObj);

var _path = require('ramda/src/path');

var _path2 = _interopRequireDefault(_path);

var _mapObjIndexed = require('ramda/src/mapObjIndexed');

var _mapObjIndexed2 = _interopRequireDefault(_mapObjIndexed);

var _values = require('ramda/src/values');

var _values2 = _interopRequireDefault(_values);

var _sequence = require('ramda/src/sequence');

var _sequence2 = _interopRequireDefault(_sequence);

var _assoc = require('ramda/src/assoc');

var _assoc2 = _interopRequireDefault(_assoc);

var _pathOr = require('ramda/src/pathOr');

var _pathOr2 = _interopRequireDefault(_pathOr);

var _prop = require('ramda/src/prop');

var _prop2 = _interopRequireDefault(_prop);

var _contains = require('ramda/src/contains');

var _contains2 = _interopRequireDefault(_contains);

var _concat = require('ramda/src/concat');

var _concat2 = _interopRequireDefault(_concat);

var _reduce = require('ramda/src/reduce');

var _reduce2 = _interopRequireDefault(_reduce);

var _map = require('ramda/src/map');

var _map2 = _interopRequireDefault(_map);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
/* eslint-disable no-nested-ternary */


exports.default = updateAsyncErrors;

var _data = require('data.task');

var _data2 = _interopRequireDefault(_data);

var _isValid = require('../utils/isValid');

var _isValid2 = _interopRequireDefault(_isValid);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Converts a list of promises into a list of Tasks that when run will either return null or the error message
 *
 * @param rules
 * @param value
 * @param form
 * @returns {Function}
 */
var createLazyPromises = function createLazyPromises(rules, value, form) {
  return (0, _map2.default)(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        promise = _ref2[0],
        errorMsg = _ref2[1];

    return new _data2.default(function (rej, res) {
      promise(value, form).then(function (valid) {
        return res(valid ? null : errorMsg);
      }, rej);
    });
  }, rules

  /**
   * @param {Array} promises expecting an array of error messages
   * @returns {Array} flattened error messages
   */
  );
};var flatErrorMsgs = (0, _reduce2.default)(function (xs, x) {
  return x ? (0, _concat2.default)(xs, [x]) : xs;
}, []

/**
 *
 * @param {[Object, Array]} state a tuple containing
 * @param {Array} effects
 * @param {Array} type
 * @param {Object} enhancedProps
 * @returns {[Object, Array]}
 */
);function updateAsyncErrors(_ref3, type, _ref4 // eslint-disable-line comma-dangle, indent
) {
  var _ref5 = _slicedToArray(_ref3, 2),
      state = _ref5[0],
      effects = _ref5[1];

  var _ref4$name = _ref4.name,
      name = _ref4$name === undefined ? '' : _ref4$name,
      value = _ref4.value,
      asyncRules = _ref4.asyncRules;

  if (!asyncRules) return [state, effects];

  if ((0, _contains2.default)(_constants.VALIDATE_FIELD, type) && (0, _prop2.default)(name, asyncRules) && (0, _isValid2.default)((0, _pathOr2.default)([], ['errors', name], state))) {
    var updatedState = (0, _assoc2.default)('pending', true, state);
    var promises = createLazyPromises(asyncRules[name], value, (0, _prop2.default)('form', state));

    var runPromises = function runPromises() {
      return (0, _sequence2.default)(_data2.default.of, (0, _values2.default)(promises)).map(function (result) {
        var asyncErrors = flatErrorMsgs(result);
        return function (prevState) {
          return _extends({}, prevState, {
            pending: false,
            errors: (0, _assoc2.default)(name, (0, _concat2.default)((0, _pathOr2.default)([], ['errors', name], prevState), asyncErrors), (0, _prop2.default)('errors', prevState))
          });
        };
      });
    };

    return [updatedState, (0, _concat2.default)(effects, [runPromises])];
  }

  if ((0, _contains2.default)(_constants.VALIDATE_ALL, type)) {
    var _updatedState = (0, _assoc2.default)('pending', true, state);
    var _promises = (0, _mapObjIndexed2.default)(function (rules, key) {
      return createLazyPromises(rules, (0, _path2.default)(['form', key], state));
    }, asyncRules);

    var _runPromises = function _runPromises() {
      return (0, _sequence2.default)(_data2.default.of, (0, _map2.default)((0, _sequence2.default)(_data2.default.of), (0, _values2.default)(_promises))).map(function (result) {
        var asyncErrors = (0, _map2.default)(flatErrorMsgs, (0, _zipObj2.default)((0, _keys2.default)(_promises), result));
        return function (prevState) {
          return _extends({}, prevState, {
            pending: false,
            errors: (0, _mergeDeepWith2.default)(_concat2.default, (0, _prop2.default)('errors', prevState), asyncErrors)
          });
        };
      });
    };

    return [_updatedState, (0, _concat2.default)(effects, [_runPromises])];
  }

  return [state, effects];
}